2022-11-30 15:28:39 +01:00
# This script installs and runs the project.
# For error-handling, we cannot use the "set -e" since: it has problems https://mywiki.wooledge.org/BashFAQ/105
# So we have our own function, for use when a single command fails.
handle_error ( ) {
echo -e " $1 " ; exit $2
}
# Change the working directory to the script's directory, when running from another location.
cd " ${ 0 %/* } " || handle_error "Could not change-dir to this script's dir!" 1
2021-09-09 14:56:37 +02:00
justInstall = 0
2022-02-04 14:49:56 +01:00
shouldRunInDocker = 0
2021-09-09 14:56:37 +02:00
if [ [ $# -eq 1 ] ] ; then
justInstall = $1
2022-02-04 14:49:56 +01:00
elif [ [ $# -eq 2 ] ] ; then
justInstall = $1
shouldRunInDocker = $2
elif [ [ $# -gt 2 ] ] ; then
2022-11-30 15:28:39 +01:00
echo -e " Wrong number of arguments given: ${# } \nPlease execute it like: script.sh <justInstall: 0 | 1> <shouldRunInDocker: 0 | 1> " ; exit 2
2022-02-04 14:49:56 +01:00
fi
if [ [ justInstall -eq 1 && shouldRunInDocker -eq 1 ] ] ; then
echo -e "Cannot run in docker without re-building the project (just to be safe). Setting \"justInstall\" to < 0 >"
justInstall = 0
2021-09-09 14:56:37 +02:00
fi
2023-02-21 14:42:07 +01:00
gradleVersion = "8.0.1"
2021-09-09 14:56:37 +02:00
if [ [ justInstall -eq 0 ] ] ; then
2021-10-14 01:46:33 +02:00
if [ [ ! -d /opt/gradle/gradle-${ gradleVersion } ] ] ; then
wget https://services.gradle.org/distributions/gradle-${ gradleVersion } -bin.zip
echo -e "\nAsking for sudo, in order to install 'gradle'..\n"
sudo mkdir /opt/gradle
sudo apt install -y unzip && sudo unzip -d /opt/gradle gradle-${ gradleVersion } -bin.zip
#ls /opt/gradle/gradle-${gradleVersion} # For debugging installation
fi
2021-09-09 14:56:37 +02:00
2022-01-21 14:45:12 +01:00
export PATH = /opt/gradle/gradle-${ gradleVersion } /bin:$PATH
2021-09-09 14:56:37 +02:00
gradle wrapper --gradle-version= ${ gradleVersion } --distribution-type= bin
#gradle tasks # For debugging installation
#gradle -v # For debugging installation
2022-02-04 14:49:56 +01:00
gradle clean build
if [ [ shouldRunInDocker -eq 1 ] ] ; then
2022-12-08 15:28:41 +01:00
echo -e "\nGive the username for the Docker Hub:"
2022-02-04 14:49:56 +01:00
read -r username
echo -e "\nBuilding docker image..\n"
2022-11-30 15:28:39 +01:00
sudo docker --version || handle_error "Docker was not found!" 3
2022-02-04 14:49:56 +01:00
dockerImage = ${ username } "/urls_controller:latest"
2023-02-02 16:58:47 +01:00
sudo docker build --no-cache -t " ${ dockerImage } " .
2022-02-23 16:40:06 +01:00
echo -e "\nPushing docker image.. (the account password is required, otherwise it will not be pushed, but it will continue to run)..\n"
2022-02-04 14:49:56 +01:00
( sudo docker login -u " ${ username } " && sudo docker push " ${ dockerImage } " ) || true
2022-02-14 11:36:00 +01:00
( sudo mkdir -p " $HOME " /tmp/config && sudo cp ./src/main/resources/application.properties " $HOME " /tmp/config) || true # This also replaces an existing "application.properties".
2022-02-04 14:49:56 +01:00
sudo docker run -d --mount type = bind,source= " $HOME " /tmp/config,target= /mnt/config -p 1880:1880 " ${ dockerImage } " && echo "The docker container started running."
# Run in "detached mode" (in the background).
fi
2021-09-09 14:56:37 +02:00
else
2022-01-21 14:45:12 +01:00
export PATH = /opt/gradle/gradle-${ gradleVersion } /bin:$PATH # Make sure the gradle is still accessible (it usually isn't without the "export").
2021-09-09 14:56:37 +02:00
fi
2022-02-04 14:49:56 +01:00
if [ [ shouldRunInDocker -ne 1 ] ] ; then
gradle bootRun
fi